<template>
  <div class="app-container">
    <div class="filter-container">
      <div class="filter-view">
        <el-select
          class="filter-input"
          placeholder="All Status"
          clearable
          @change="onClickSearch"
          v-model="filters.pageVo.dataStatus">
          <el-option
            v-for="(item,index) in options.status"
            :key="index"
            :label="item.name"
            :value="item.value"/>
        </el-select>
        <el-select
          class="filter-input"
          @change="onClickSearch"
          placeholder="All Article Type"
          v-model="filters.pageVo.articleTypeId"
          clearable>
          <el-option
            v-for="(item,index) in options.types"
            :key="index"
            :label="item.name"
            :value="item.value"/>
        </el-select>
        <div
          class="filter-flex-button"
          v-if="!$route.meta.onlyView">
          <el-button
            icon="el-icon-plus"
            type="primary"
            @click="onClickAdd">
            Create
          </el-button>
        </div>
      </div>
    </div>
    <el-table
      v-loading="loading"
      :data="table.list">
      <el-table-column
        align="center"
        label="Article ID"
        prop="userPk"
        min-width="120">
        <template slot-scope="{row}" >
          <span
            class="link-type"
            @click="onClickEdit(row)"
            v-if="!$route.meta.onlyView">
            {{ row.articleId }}
          </span>
          <span v-else>{{ row.articleId }}</span>
        </template>
      </el-table-column>
      <el-table-column
        align="center"
        label="Title"
        prop="articleTitle"
        min-width="150"/>
      <el-table-column
        align="center"
        label="Article Type"
        prop="articleTypeName"
        min-width="100"/>
      <el-table-column
        align="center"
        label="Posted By"
        prop="createBy"
        min-width="120"/>
      <el-table-column
        align="center"
        label="Posted Date"
        prop="createTime"
        min-width="120"/>
      <el-table-column
        align="center"
        label="Views"
        prop="views"
        min-width="80"/>
      <el-table-column
        align="center"
        label="Status"
        prop="dataStatus"
        min-width="80"/>
      <el-table-column
        align="center"
        label="Action"
        min-width="120"
        v-if="!$route.meta.onlyView">
        <template v-slot="{ row }">
          <TableAction
            @edit="onClickEdit(row)"
            @delete="onClickDelete(row)"
            v-if="row.dataStatus != 'Inactive'"/>
        </template>
      </el-table-column>
    </el-table>
    <div class="right">
      <pagination
        v-show="table.total > 0"
        :total="table.total"
        :page.sync="filters.pageNo"
        :limit.sync="filters.pageSize"
        @pagination="getTableData" />
    </div>
  </div>
</template>

<script>
import TableAction from '@/components/TableAction.vue'
import Pagination from '@/components/Pagination'
import charge from '../../http/api/charge'
import api from '../../api/article.js'
export default {
  data() {
    return {
      loading: false,
      filters: {
        pageNo: 1,
        pageSize: 10,
        pageVo: {
          criteria: "",
          dataStatus: "",
          articleTypeId: ""
        }
      },
      table: {
        list: [],
        total: 0
      },
      options: {
        status: [],
        types: []
      }
    };
  },
  components: { Pagination, TableAction },
  created() {
    this.getStatusOptions();
    this.onClickSearch();
  },
  methods: {
    onClickSearch() {
      this.filters.pageNo = 1
      this.getTableData()
    },
    getStatusOptions() {
      charge.getStatusOptions().then(res => {
        this.options.status = res.data;
      }).catch(err => {
        this.$message.error(err);
      }).finally(() => {
        this.getArticleTypeOptions()
      });
    },
    getArticleTypeOptions() {
      api.getArticleTypeOption().then(res => {
        this.options.types = res.data;
      }).catch(err => {
        this.$message.error(err);
      });
    },
    getTableData() {
      this.loading = true;
      api.getArticlePages(this.filters).then(res => {
        if (res.data && res.total) {
          this.table.total = res.total;
          this.table.list = res.data;
        } else {
          this.table.total = 0;
          this.table.list = [];
        }
      }).catch(err => {
        this.$message({
          type: 'error',
          message: err
        })
        this.table.total = 0;
        this.table.list = [];
      }).finally(() => {
        this.loading = false;
      })
    },
    onClickAdd() {
      this.$router.push({
        path: "/marketing-management/article/create"
      })
    },
    onClickEdit(row) {
      this.$router.push({
        path: "/marketing-management/article/update/" + row.articleId
      })
    },
    onClickDelete(row) {
      this.$confirm('Are you sure you want to delete this article?', 'Delete', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(res => {
        this.onDeleteArticle(row.articleId)
      })
    },
    onDeleteArticle(id) {
      this.loading = true;
      api.deleteArticle(id).then(res => {
        this.$message({
          type: 'success',
          message: "Delete success."
        })
        this.getTableData()
      }).catch(err => {
        this.$message({
          type: 'error',
          message: err
        })
        this.loading = false;
      })
    }
  }
}
</script>

<style scoped>
.filter-input {
  min-width: 100px;
  max-width: 300px;
}
</style>